<!DOCTYPE html>
{% load static %}
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="icon" type="image/png" href="{% static 'admin/images/favicon/android-chrome-100x100.png' %}">

    {% if title %}
        <title>{{ title }} | Manage Panel</title>
    {% else %}
        <title>Manage Panel</title>
    {% endif %}
    
    <!-- JS -->
    {% block scripts %} {% endblock scripts %}

    <!-- CSS -->

    <link rel="stylesheet" type="text/css" href="{% static 'admin/css/bootstrap.min.css' %}">
    <link rel="stylesheet" type="text/css" href="{% static 'admin/css/bootstrap-icons-1.8.3/bootstrap-icons.css' %}">
    <link rel="stylesheet" type="text/css" href="{% static 'admin/css/boxicons/css/boxicons.min.css' %}">
    <link rel="stylesheet" type="text/css" href="{% static 'admin/css/fontawesome-free/css/all.min.css' %}">
    <link rel="stylesheet" type="text/css" href="{% static 'admin/css/sb-admin/sb-admin-2.css' %}">
    

    <link href="{% static 'admin/plugin/select2/select2.min.css' %}" rel="stylesheet" />
    <link rel="stylesheet" type="text/css" href="{% static 'admin/css/datatables/datatables.min.css' %}">
    <link rel="stylesheet" type="text/css" href="{% static 'admin/css/datatables/datatables-responsive.css' %}">
    <style>
    .shadow1{
        box-shadow: 14px 29px 34px -30px rgba(0,0,0,0.5);
        -webkit-box-shadow: 14px 29px 34px -30px rgba(0,0,0,0.5);
        -moz-box-shadow: 14px 29px 34px -30px rgba(0,0,0,0.5);
    }
    </style>
    {% block css %} {% endblock css %}

</head>
<body id="kt_bodyyyyyyyyyy">
    <div id="wrapper">
        {% if messages %}
            {% for message in messages %}
            <div alt="{{message.tags}}" data="{{message}}" id="msg_pesan"></div>
            {% endfor %}
        {% endif %}
        {% include 'profile/layouts/admin/sidebar.html' %}
        <div id="content-wrapper" class="d-flex flex-column">
            <div id="content">
                    {% block navbar %} {% endblock navbar %}
                
                <div style="padding-top: 100px;" class="container-fluid">
                    {% block main %} {% endblock main %}
                </div>
            </div>
        </div>
    </div>
    
    <a class="scroll-to-top rounded" href="#page-top">
        <i class="bi bi-arrow-up"></i>
    </a>
    
    {% block modal %} {% endblock modal %}

    {% block footer %} {% endblock footer %}

    <!-- Optional JavaScript -->
    <!-- jQuery first, then Popper.js, then Bootstrap JS -->
    <script src="{% static 'admin/js/jquery-3.2.1.min.js' %}"></script>
    <script src="{% static 'admin/js/popper.min.js' %}"></script>
    <script src="{% static 'admin/js/bootstrap.min.js' %}"></script>
    <script src="{% static 'admin/js/sb-admin/sb-admin-2.js' %}"></script>
    <script src="{% static 'admin/js/sweetalert2.min.js' %}"></script>
    <script src="{% static 'admin/plugin/select2/js/select2.min.js' %}"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery.blockUI/2.70/jquery.blockUI.min.js"></script>
    <script src="https://cdn.datatables.net/2.2.1/js/dataTables.js"></script>
    <script src="https://cdn.datatables.net/2.2.1/js/dataTables.bootstrap5.js"></script>
    <script src="https://cdn.datatables.net/responsive/3.0.3/js/dataTables.responsive.js"></script>
    <script src="https://cdn.datatables.net/responsive/3.0.3/js/responsive.bootstrap5.js"></script>
    <script type="text/javascript">
        function show_notif(meseg,jenis_icon){
            if(jenis_icon == 'error'){
                button_style = 'btn-danger'
            }else{
                button_style = `btn-${jenis_icon}`
            }
            
            Swal.fire({
                html: meseg,
                icon: jenis_icon,
                buttonsStyling: false,
                confirmButtonText: "Ok",
                customClass: {
                            confirmButton: `btn ${button_style}`
                        }
            });
        }

        if ($('#msg_pesan').length){
            show_notif($("#msg_pesan").attr('data'), $("#msg_pesan").attr('alt'));
        }

        function to_currency_indo(value, thousand_separator = '.', decimal_separator = ','){
          var str = value.toString().replace("", ""), parts = false, output = [], i = 1, formatted = null;
              if(str.indexOf(`${decimal_separator}`) > 0) {
                parts = str.split(`${decimal_separator}`);
                str = parts[0];
              }

              if(!parts){
                parts = [str, '00']
              }
              
              // console.log(parts)
              str = str.split("").reverse();
              for(var j = 0, len = str.length; j < len; j++) {
                if(str[j] != `${thousand_separator}`) {
                  output.push(str[j]);
                  if(i%3 == 0 && j < (len - 1)) {
                    output.push(`.`);
                  }
                  i++;
                }
              }
              formatted = output.reverse().join("");
          return("" + formatted + ((parts) ? `,` + parts[1].substr(0, 2) : ""));

          // value_ = `Rp${value}`
          // return value_
        }

        function from_currency_indo(formattedValue, thousand_separator = '.', decimal_separator = ',') {
            // Hapus semua pemisah ribuan (thousand_separator)
            let rawValue = formattedValue.split(thousand_separator).join('');
            
            // Ganti pemisah desimal dengan titik agar sesuai dengan format JavaScript
            rawValue = rawValue.replace(decimal_separator, '.');

            // Konversi ke angka desimal (float)
            return parseFloat(rawValue);
        }

        function check_required(form_element){
          var is_valid = true


          $('[required]').each(function( index ) {
            if($(this).val() == ''){
              is_valid = false
              form_element.addClass('was-validated')
              // $('.feedback_error').remove();
              // $(this).parent().append('<div class="fv-plugins-message-container fv-plugins-message-container--enabled invalid-feedback feedback_error">Tidak Boleh Kosong</div>')
              return is_valid;
            }else{
                form_element.removeClass('was-validated')
              // $('.feedback_error').remove();
            }
          });

          return is_valid
        }

        $(document).on('keydown', '.currency', function(event) {
          e = event;
          // Allow: backspace, delete, tab, escape, enter and .
            if ($.inArray(e.keyCode, [46, 8, 9, 27, 13, 110, 188,173]) !== -1 ||
              // Allow: Ctrl+A,Ctrl+C,Ctrl+V, Command+A
              ((e.keyCode == 65 || e.keyCode == 86 || e.keyCode == 67 || e.keyCode == 88 || e.keyCode == 90 || e.keyCode == 89) && (e.ctrlKey === true || e.metaKey === true)) ||
              // Allow: home, end, left, right, down, up
              (e.keyCode >= 35 && e.keyCode <= 40)) {
              // let it happen, don't do anything
              return;
            }
            
            
            // Ensure that it is a number and stop the keypress
            if ((e.shiftKey || (e.keyCode < 48 || e.keyCode > 57)) && (e.keyCode < 96 || e.keyCode > 105)) {
              e.preventDefault();
            }
        })

        $(document).on('blur', '.currency', function(event) {
            if($(this).val() != ''){
                $(this).val(to_currency_indo($(this).val()));
            }else{
                $(this).val(to_currency_indo('0'));
            }
        })

        $(document).on('focus', '.currency', function(event) {
          $(this).select();
        })


        function hideModal(e){
          e.removeClass('show');
          e.modal('hide');
        }

        $('.close_modal_report').click(function(){
            hideModal($('#modal_report'))   
        })

        function hideModal_this(){
            hideModal($('#modal_report'))   
        }

        modal_report_element = `<div class="modal fade" tabindex="-1" id="modal_report" style="z-index: 1056 !important;">
                    <div class="modal-dialog modal-dialog-centered modal-xl">
                        <div class="modal-content">
                            <div class="modal-header">
                                <h5 class="modal-title-report" id="modal-title-report">-</h5>

                                <!--begin::Close-->
                                <div class="btn btn-icon btn-sm btn-active-light-primary ms-2 close_modal_report" onclick="hideModal_this()" data-modal="modal_report" data-bs-dismiss="modal_report" aria-label="Close">
                                    <!--begin::Svg Icon | path: /var/www/preview.keenthemes.com/kt-products/docs/metronic/html/releases/2022-09-15-053640/core/html/src/media/icons/duotune/general/gen034.svg-->
                                      <span class="svg-icon svg-icon-muted svg-icon-2hx"><svg width="24" height="24" viewBox="0 0 24 24" fill="none" xmlns="http://www.w3.org/2000/svg">
                                      <rect opacity="0.3" x="2" y="2" width="20" height="20" rx="5" fill="currentColor"/>
                                      <rect x="7" y="15.3137" width="12" height="2" rx="1" transform="rotate(-45 7 15.3137)" fill="currentColor"/>
                                      <rect x="8.41422" y="7" width="12" height="2" rx="1" transform="rotate(45 8.41422 7)" fill="currentColor"/>
                                      </svg>
                                      </span>
                                      <!--end::Svg Icon-->
                                            </div>
                                <!--end::Close-->
                            </div>

                            <div class="modal-body-report">
                                <p></p>
                            </div>

                            <!-- <div class="modal-footer">
                                <button type="button" class="btn btn-primary">Simpan</button>
                            </div> -->
                        </div>
                    </div>
                </div>`

        function ShowIframeReport(res, title, ev = null){
            if(ev != null){
                ev.preventDefault()
            }

            $('body').append(modal_report_element);

            var ifrm = document.createElement("iframe");
              
            ifrm.setAttribute("src", res+"");  
            ifrm.setAttribute("id", 'iframe_report');  
            ifrm.setAttribute("frameborder", 0);
            ifrm.style.width  = "100%";
            ifrm.style.height = "800px";
            // ifrm.style.background = "#F6F6F6";
            // ifrm.style.background = "url(/static/images/loading.gif) no-repeat center top";

            // var myModal_report_ = document.getElementById('modal_report');
            
            // var myModal_report = new bootstrap.Modal(myModal_report_, {
            //   keyboard: false,
            //   backdrop: 'static',
            //   focus:true
            // })

            $('#modal-title-report').text(title);

            $(".modal-body-report").html(ifrm);
            
            // myModal_report_.addEventListener('show.bs.modal', function (event) {
            //     close_notif();
            //     // show_loader();
            // })

            $('#modal_report').on('hide.bs.modal', function (e) {
              $('#modal_report').remove();
            })

            $('#modal_report').modal('show');
            
            $('#iframe_report').on('load', function(){
                // close_notif();
            });

        }
        function showModal(trigger, { size = 'fullscreen' } = {}) {
            let modalSizes = {
                'small': 'modal-sm',
                'large': 'modal-lg',
                'fullscreen': 'modal-xl'
            };
        
            let title = trigger.getAttribute('data-modal-title') || 'Modal';
            let url = trigger.getAttribute('data-alt') || '#';
        
            let modalId = `modal_${size}`;
            let existingModal = document.getElementById(modalId);
        
            // Hapus modal lama jika sudah ada
            if (existingModal) {
                existingModal.remove();
            }
        
            // Buat modal baru
            let modalHtml = `
                <div class="modal fade" id="${modalId}" tabindex="-1" aria-hidden="true">
                    <div class="modal-dialog ${modalSizes[size] || 'modal-xl'}">
                        <div class="modal-content">
                            <div class="modal-header">
                                <h5 class="modal-title">${title}</h5>
                                <button class="btn" type="button" data-dismiss="modal"><i class="fa fa-times"></i></button>
                                
                                </button>
                            </div>
                            <div class="modal-body">
                                <div class="text-center">Loading...</div>
                            </div>
                        </div>
                    </div>
                </div>
            `;
        
            // Tambahkan modal ke dalam body
            document.body.insertAdjacentHTML('beforeend', modalHtml);
        
            let modalElement = document.getElementById(modalId);
            let modal = new bootstrap.Modal(modalElement, {
                keyboard: false,
                backdrop: 'static'
            });
        
            // Load konten dari URL
            $.ajax({
                url: url,
                data: {},
                dataType: "html",
                timeout: 10000,
                beforeSend: function() {
                    Swal.fire({
                        title: 'Memproses.........',
                        allowEscapeKey: false,
                        allowOutsideClick: false,
                        showCancelButton: false,
                        showConfirmButton: false,
                        onOpen: () => {
                            swal.showLoading();
                        }
                    });
                },
                success: function(response){
                    modalElement.querySelector('.modal-body').innerHTML = response;
                    Swal.close();
                    modal.show();
                },
                error: function (xhr, ajaxOptions, thrownError) {
                    try{
                        if(xhr.responseJSON != undefined){
                            data_error = xhr.responseJSON
                        }else{
                            data_error = JSON.parse(xhr.responseText)
                        }
                    }catch(err){
                        data_error = JSON.parse(xhr.responseText)
                    }

                    try{
                        show_notif(data_error.message, data_error.status);
                    }catch(err){
                        modalElement.querySelector('.modal-body').innerHTML = `<div class="text-danger">Gagal memuat data</div>`;
                    }
                }
            });

            // fetch()
            //     .then(response => response.text())
            //     .then(data => {
            //         console.log(data)
                    
            //     })
            //     .catch(error => {
                    
            //     });
        
            // Tampilkan modal
            
        
            // Event saat modal ditutup
            modalElement.addEventListener('hidden.bs.modal', function () {
                modalElement.remove(); // Hapus modal dari DOM setelah ditutup
            });
        }
        
    </script>

    <script>
        $(document).ready(function() {
            $('.list_wilayah').select2();
            $('.list_tahun').select2();
            $('.select2').select2();
            

            let isLaptopOrLarger = window.matchMedia('(max-width: 1024px)').matches;
                $('[data-tooltip="tooltip"]').tooltip();
                $('#table-list').DataTable({
                    responsive: isLaptopOrLarger,
                    info: false,
                    searching: false,
                    "bPaginate": false
                });
                $('#table-archive').DataTable({
                    responsive: isLaptopOrLarger
                });

                var urlParams = new URLSearchParams(window.location.search);
                  $('.filter').each(function(i, obj) {
                      if(urlParams.has($(this).data('filter'))){
                          $(this).val(urlParams.get($(this).data('filter')))
                      }
                  });
            
        });
        var csrf_token = "{{csrf_token}}";
        
        $(function () {
            $('[data-toggle="tooltip"]').tooltip()
        })

        $('.btn-paginate').click(function(event){
                set_param(this, event, 'page')
        })

        function filter_data(e, ev, reset){
            filtering_param = {}
            $('.filter').each(function(i, obj) {
                filtering_param[$(this).data('filter')] = $(this).val()

            });
            set_param(e, ev, filtering_param, reset)

        }

        function set_param(e, ev, param, reset = false){
                ev.preventDefault();
                
                var urlParams = new URLSearchParams(window.location.search);
                var url_reload = '';

                if($.type(param) == 'object'){
                  $.each(param, function(key, value) {
                  if (reset){
                    urlParams.delete(`${key}`, value)
                  }else{
                    urlParams.set(`${key}`, value)
                  }
                  });
                }else{
                  var value = $(e).val() == "" ? $(e).data('value') : $(e).val() ;
                  urlParams.set(`${param}`, value)
                }
                
                window.location.search = urlParams.toString();
            }

        function is_param_exists(param){
            var urlParams = new URLSearchParams(window.location.search);
            is_exist = urlParams.get(param)
            if (is_exist != null) {
                return true;
            }else{
                return false;
            }
        }
        
        function logout(){
            Swal.fire({
                title: `Apakah anda yakin ingin keluar?`,
                showCancelButton: true,
                confirmButtonText: 'Keluar',
                cancelButtonText: 'Batal',
                }).then((result) => {
                if (result.isConfirmed) {
                    $.ajax({
                        url: `{% url 'logout' %}`,
                        data: {},
                        dataType: "html",
                        timeout: 10000,
                        beforeSend: function() {
                            Swal.fire({
                                title: 'Memproses.........',
                                allowEscapeKey: false,
                                allowOutsideClick: false,
                                showCancelButton: false,
                                showConfirmButton: false,
                            });
                            Swal.showLoading();
                        },
                        success: function(response){
                            Swal.fire(`Berhasil Logout!`, '', 'success');
                            setTimeout(function(){
                                window.location.href = "{% url 'login' %}";
                            }, 2000); 
                        },
                        error: function (xhr, ajaxOptions, thrownError) {
                            Swal.fire(`Gagal Logout`, '', 'error');
                        }
                    });
                    
                }
            });
        }
    </script>
    <script>
        document.addEventListener("DOMContentLoaded", function () {
            let sidebar = document.querySelector(".sidebar-dark.accordion");
            let content = document.querySelector(".navbar1");
        
            function updateNavbarWidth() {
                let sidebarWidth = sidebar.offsetWidth;
                content.style.width = `calc(100% - ${sidebarWidth}px)`;
            }
        
            // Cek perubahan kelas pada sidebar
            let observer = new MutationObserver(updateNavbarWidth);
            observer.observe(sidebar, { attributes: true, attributeFilter: ["class"] });
        
            // Cek perubahan ukuran jendela
            window.addEventListener("resize", updateNavbarWidth);
        
            // Update pertama kali saat halaman dimuat
            updateNavbarWidth();
        });
    </script>
        
        
    {% block scripts_bawah %} {% endblock scripts_bawah %}

</body>
</html>

